#ifndef BUFFERING_H
#define BUFFERING_H

#include <QObject>
#include "voltagedata.h"

#define WARN_TOO_AHEAD 1
#define WARN_TOO_PREVIOUS 2
class Buffering : public QObject
{
    Q_OBJECT
public:
    explicit Buffering(unsigned int vol_thres = 15, unsigned int idx_thres = 5, QObject *parent = 0);
signals:
    void started(bool);
    void stopped(std::array<std::vector<unsigned int>, 8>*, bool);
    void warn(int);
public slots:
    void write(const volt_data*);
    void stop();
private:
    bool isstarted;
    unsigned int m_vol_thres;
    unsigned int m_idx_thres;
    std::array<std::vector<unsigned int>, 8>* data; // The Default doesn't copy the whole vector.
    std::array<unsigned int, 8> threscnt;
    //std::array<unsigned int, 8> rescnt;
    unsigned int sindex;
};

#endif // BUFFERING_H
