#include "testing.h"
#include "svm.h"
Testing::Testing(DataEntry& de, QObject *parent) :
    mde(de), QObject(parent)
{
}

void constructFeature(const std::vector<double>& feature, svm_node* vec)
{
    for(unsigned j = 0; j < feature.size(); j++)
    {
        vec[j].index = j;
        vec[j].value = feature[j];
    }
    vec[feature.size()].index = -1;
}

void Testing::test(const std::vector<double>& feature)
{
    svm_node* tmp = new svm_node[feature.size()+1];
    constructFeature(feature, tmp);

    double vx = svm_predict(mde.getSVMModel(), tmp);

    unsigned x = (unsigned int)vx;
    delete [] tmp;
    emit result(x);
    int num = svm_get_nr_class(mde.getSVMModel());
    double* probs = new double[num];
    svm_predict_probability(mde.getSVMModel(), tmp, probs);
    printf("p1:%lf", probs[0]);
    printf("p2:%lf", probs[1]);
    emit probResult(probs, num);
    delete [] probs;
}
