  #include <STC15.h>
#include<intrins.h>
#include<stdio.h>
#define uchar unsigned char
#define uint unsigned int
#define FOSC 18432000L
#define BAUD 9600
#define Wait1us      _nop_();
#define Wait2us     {_nop_();_nop_();}
#define Wait4us     {Wait2us;Wait2us;}
#define Wait8us     {Wait4us;Wait4us;}
#define Wait10us    {Wait8us;Wait2us;}

sbit AD_eoc=P1^0;
sbit AD_clk=P1^1;
sbit AD_add=P1^2;
sbit AD_dat=P1^3;
sbit AD_cs=P1^4;

uchar flag,a,port,chan,h,m;
unsigned char flag_uart,flag_time,flag_on,a,i,t0_num;
uint ad_val;
float ad_vo;
unsigned long cnt = 0;
uchar oput[8];
void init()
{
	AUXR=0x40;
	TMOD=0X21;
	SCON=0X50;
	TH0=(65536-1300)/256;
	TL0=(65536-1300)%256;
	TH1 = TL1 = 0xFD;

	TR1=1;
	ET0=1;
	SM0=0;
	SM1=1;
	REN=1;
	EA=1;
	ES=1;
}

uint ADC(uchar chn1)
{
	uint i;
	uchar delay;		   
	uint  ADresult;
	uchar ConvertValueL=0;
	uchar ConvertValueH=0;
	delay=0;	
		  
	if(AD_eoc)
	{   
		AD_clk=0;
		AD_cs=1;
		Wait2us;
		AD_cs=0;
		_nop_();
		chn1<<=4;
	}

	for(i=0;i<4;i++)
	{	    
		AD_add= (bit)(chn1&0x80);
		Wait2us;
		AD_clk = 1;
		AD_clk = 0;
		chn1 = chn1 << 1;		
	}
	
	for(i=0;i<6;i++)
	{
		AD_clk=1;
		AD_clk=0;	
	}
	
	AD_cs=1;

	while((!AD_eoc) && (delay < 10));
 	{
	   	Wait10us;
	   	delay ++;
	}

	ADresult=0;
	Wait10us;
	AD_clk = 0 ;
	AD_cs=1;	
	Wait1us;
	AD_cs= 0;
	Wait1us;	   

	for(i=0;i<2;i++)
	{
		AD_dat=1;
		AD_clk=1;
		ConvertValueH<<=1;
		if(AD_dat)
			ConvertValueH|=0x01;
		AD_clk=0;
		Wait1us;
	}
	
	for(i=0;i<8;i++)
	{
		AD_dat=1;
		AD_clk=1;
		ConvertValueL<<=1;
		if(AD_dat)
			ConvertValueL|=0x01;
		AD_clk=0;
		Wait1us;
	}	   

		AD_cs=1;
		ADresult=(uint)ConvertValueH;
		ADresult<<=8;
		ADresult|=ConvertValueL;
		return(ADresult);
}

void main()
{
	uchar j;
	uchar chk;
  init();
	while(1)
	{
		chan=0x07;
		h='A';
		cnt++;
		for(j=0;j<8;j++,h++)
		{
			port=chan-j;
			flag_uart=0;
			ES=0;
			TI=1;
			TR0=1;
			while(!TI);
			TI=0;
			ES=1;
			
			if(flag_time==1)
			{
				flag_time=0;
				ad_val=ADC(port);
				ES=0;
				TI=1;

				oput[0] = port;
				oput[1] = cnt >> 24;
				oput[2] = cnt >> 16;
				oput[3] = cnt >> 8;
				oput[4] = cnt;
				oput[5] = ad_val >> 8;
				oput[6] = ad_val;
				oput[7] = oput[0] ^ oput[1] ^ oput[2] ^ oput[3] ^ oput[4] ^ oput[5] ^ oput[6];

				while(printf("%c%c%c%c%c%c%c%c", oput[0], oput[1], oput[2], oput[3], oput[4], oput[5], oput[6], oput[7])<0);
				while(!TI);
				TI=0;
				ES=1;
			}
		}
	}
}

void timer0() interrupt 1
{
	TH0=(65536-1300)/256;
	TL0=(65536-1300)%256;
	t0_num++;
	if(t0_num==1)
	{
		t0_num=0;
		flag_time=1;
	}
}

void ser() interrupt 4
{
flag_uart=1;
}
